package org.erachain.gui.items.persons;
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

import org.erachain.core.account.PublicKeyAccount;
import org.erachain.core.crypto.Base58;
import org.erachain.core.item.persons.PersonCls;
import org.erachain.core.item.persons.PersonHuman;
import org.erachain.core.transaction.Transaction;
import org.erachain.datachain.DCSet;
import org.erachain.gui.items.ImageCropDialog;
import org.erachain.gui.items.TypeOfImage;
import org.erachain.gui.library.*;
import org.erachain.lang.Lang;
import org.erachain.utils.MenuPopupUtil;

import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.image.BufferedImage;

/**
 * @author РЎР°С€Р°
 */
public class PersonClsInfo002 extends javax.swing.JPanel {

    /**
     *
     */
    private static final long serialVersionUID = 1L;
    public StatusesLibraryPanel statuses_Library_Panel;
    public AccountsLibraryPanel accounts_Library_Panel;
    public SignLibraryPanel voush_Library_Panel;
    public PersonMakerPanel person_Maker_Panel;
    public PersonSignedPanel personSignedPanel;
    ImageIcon image;
    /**
     * Creates new form PersonClsInfo002
     */

    //private PersonHuman human;
    private PublicKeyAccount publisher;
    // Variables declaration - do not modify
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel_Creator;
    private javax.swing.JLabel jLabel_Date_Born;
    private javax.swing.JLabel jLabel_Description;
    private javax.swing.JLabel jLabel_Gender;
    private javax.swing.JLabel jLabel_Name;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel_Image;
    private javax.swing.JScrollPane jScrollPane1;
    private MTextPane jTextArea_Description;
    private javax.swing.JTextField jTextField1;
    private MAccoutnTextField jTextField_Creator;
    private javax.swing.JTextField jTextField_Date_Born;
    private javax.swing.JTextField jTextField_Gender;
    private javax.swing.JTextField jTextField_Name;
    private javax.swing.JLabel jLabel_Maker;
    private MAccoutnTextField jTextField_Maker;
    private javax.swing.JLabel jLabel_Maker_Sign;
    private javax.swing.JTextField jTextField_Maker_Sign;

    public PersonClsInfo002(PersonCls person, boolean full) {
        if (person != null) initComponents(person, full);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    private void initComponents(PersonCls person, boolean full) {
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel3 = new javax.swing.JPanel();
        jLabel_Name = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jTextField_Name = new javax.swing.JTextField();
        jLabel_Description = new javax.swing.JLabel();
        jLabel_Date_Born = new javax.swing.JLabel();
        jTextField_Date_Born = new javax.swing.JTextField();
        jLabel_Gender = new javax.swing.JLabel();
        jTextField_Gender = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea_Description = new MTextPane();
        jLabel_Creator = new javax.swing.JLabel();
//		jTextField_Creator = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jPanel_Image = new javax.swing.JPanel();

        jLabel_Maker = new javax.swing.JLabel();

        //	jTextField_Maker = new javax.swing.JTextField();
        new javax.swing.JTextField();
        jLabel_Maker_Sign = new javax.swing.JLabel();
        jTextField_Maker_Sign = new javax.swing.JTextField();

        PublicKeyAccount author = null;
        Transaction issue_record;
        byte[] recordReference = person.getReference();
        if (recordReference != null) {
            // если персона взята из буфера и еще не добавлялась то тут НУЛЬ будет
            issue_record = Transaction.findByDBRef(DCSet.getInstance(), recordReference);
            publisher = issue_record.getCreator();
        } else {
            issue_record = null;
            boolean debug = true;
        }

        PersonHuman human = person instanceof PersonHuman ? (PersonHuman) person : null;

        author = person.getAuthor();

        setMinimumSize(new java.awt.Dimension(100, 100));
        setLayout(new java.awt.GridBagLayout());

        jPanel3.setLayout(new java.awt.GridBagLayout());
        JPanel jPanel1 = new javax.swing.JPanel();
        //	 jPanelHead.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel1.setLayout(new java.awt.GridBagLayout());
        JLabel jLabel1N = new JLabel();
        jLabel1N.setText(Lang.T("Name") + ":");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.insets = new java.awt.Insets(8, 8, 3, 0);
        jPanel1.add(jLabel1N, gridBagConstraints);

        javax.swing.JTextField jTextField1N;
        jTextField1N = new JTextField();
        jTextField1N.setEditable(false);
        jTextField1N.setText(person.viewName());
        MenuPopupUtil.installContextMenu(jTextField1N);
        jTextField1N.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField_NameActionPerformed(evt);
            }
        });


        //   jTextField1N.setMinimumSize(new java.awt.Dimension(120, 20));
        jTextField1N.setName(""); // NOI18N
        //   jTextField1N.setPreferredSize(new java.awt.Dimension(120, 20));
        //    jTextField1N.setRequestFocusEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(8, 4, 3, 0);
        jPanel1.add(jTextField1N, gridBagConstraints);


        JLabel lbl_Block = new JLabel(Lang.T("Block") + ":");

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        //  gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_END;
        //   gridBagConstraints.weightx = 0.1;
        gridBagConstraints.insets = new java.awt.Insets(8, 8, 3, 8);

        jPanel1.add(lbl_Block, gridBagConstraints);

        if (issue_record != null) {
            JTextField txt_Block = new JTextField(issue_record.viewHeightSeq());

            txt_Block.setEditable(false);
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 4;
            gridBagConstraints.gridy = 0;
            gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
            gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
            gridBagConstraints.weightx = 0.1;
            gridBagConstraints.insets = new java.awt.Insets(8, 8, 3, 8);

            jPanel1.add(txt_Block, gridBagConstraints);
            MenuPopupUtil.installContextMenu(txt_Block);
            txt_Block.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    jTextField_NameActionPerformed(evt);
                }
            });
        }

        MButton btn_Block = new MButton(Lang.T("Deals"), 2.0);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 0.1;
        gridBagConstraints.insets = new java.awt.Insets(8, 8, 3, 8);

        if (person.isConfirmed()) {
            //  jPanelHead.add(btn_Block, gridBagConstraints);
            btn_Block.addMouseListener(new MouseListener() {

                @Override
                public void mouseClicked(MouseEvent arg0) {
                    // TODO Auto-generated method stub
                    PersonWorkDialog pWD = new PersonWorkDialog(person);

                    pWD.setLocation(arg0.getXOnScreen() - pWD.getWidth(), arg0.getYOnScreen());
                    pWD.setVisible(true);
                }

                @Override
                public void mouseEntered(MouseEvent arg0) {
                    // TODO Auto-generated method stub

                }

                @Override
                public void mouseExited(MouseEvent arg0) {
                    // TODO Auto-generated method stub

                }

                @Override
                public void mousePressed(MouseEvent arg0) {
                    // TODO Auto-generated method stub

                }

                @Override
                public void mouseReleased(MouseEvent arg0) {
                    // TODO Auto-generated method stub

                }

            });
        }

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 0.1;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 0);

        add(jPanel1, gridBagConstraints);

        jLabel_Name.setText(Lang.T("Name") + ":");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 3);
        //	add(jLabelName, gridBagConstraints);

        jTextField_Name.setEditable(false);
        jTextField_Name.setText(person.viewName());
        MenuPopupUtil.installContextMenu(jTextField_Name);
        jTextField_Name.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField_NameActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 0.1;
        //	add(jTextField_Name, gridBagConstraints);

        jLabel_Description.setText(Lang.T("Description") + ":");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 2);
        jPanel3.add(jLabel_Description, gridBagConstraints);

        //jTextArea_Description.setRows(5);

        MenuPopupUtil.installContextMenu(jTextArea_Description);
        //jTextArea_Description.setEditable(false);
        //jTextArea_Description.setWrapStyleWord(true);
        //jTextArea_Description.setLineWrap(true);


        String descript = "";
        String biStr = person.viewStartDate();
        if (!person.isAlive(System.currentTimeMillis())) {
            descript += "<b>" + biStr + " - " + person.viewStopDate();
        } else {
            descript += Lang.T("Birthday") + ":" + "<b>" + biStr;
        }

        if (human != null) {
            descript += Lang.T("Gender") + ": <b>";
            if (human.getGender() == 0) {
                descript += Lang.T("Male");
            } else if (human.getGender() == 1) {
                descript += Lang.T("Female");
            }
            descript += "</b>, ";

            descript += "</b>, " + Lang.T("Coordinates of Birth") + ": <b>" + ((Float) human.getBirthLatitude()) + "," + ((Float) human.getBirthLongitude()) + "</b>, ";
            descript += Lang.T("P.Height") + ": <b>" + human.getHumanHeight() + "</b>";

        }


        descript = descript + "<br>" + Library.to_HTML(person.getDescription());
        jTextArea_Description.setText("<html>" + descript);

        jScrollPane1.setViewportView(jTextArea_Description);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        // gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        // gridBagConstraints.weightx = 0.1;
        gridBagConstraints.weighty = 0.6;
        jPanel3.add(jScrollPane1, gridBagConstraints);

        int gridy = 8;
        if (author != null && !author.equals(publisher)) {

            jLabel_Maker.setText(Lang.T("Data creator") + ":");
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.gridy = gridy++;
            gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
            gridBagConstraints.insets = new java.awt.Insets(2, 0, 0, 2);
            jPanel3.add(jLabel_Maker, gridBagConstraints);

            jTextField_Maker = new MAccoutnTextField(author);
            jTextField_Maker.setEditable(false);
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.gridy = gridy++;
            gridBagConstraints.gridwidth = 3;
            gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
            gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
            gridBagConstraints.weightx = 0.2;
            gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 0);
            jPanel3.add(jTextField_Maker, gridBagConstraints);

            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.gridy = gridy++;
            gridBagConstraints.gridwidth = 3;
            gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
            gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
            gridBagConstraints.weightx = 0.2;
            gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 0);


            jLabel_Maker_Sign.setText(Lang.T("Maker Sign") + ":");
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.gridy = gridy++;
            gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
            gridBagConstraints.insets = new java.awt.Insets(2, 0, 0, 2);
            //	jPanel3.add(jLabel_Maker_Sign, gridBagConstraints);

            jTextField_Maker_Sign.setEditable(false);

            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.gridy = gridy++;
            gridBagConstraints.gridwidth = 3;
            gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
            gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
            gridBagConstraints.weightx = 0.2;
            gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 0);

            if (human != null) {
                jTextField_Maker_Sign.setText(human.isSignatureValid() ? Base58.encode(human.getAuthorSignature())
                        : Lang.T("Wrong signature for data author"));
            }
        }

        jLabel_Creator.setText(Lang.T("Registrar") + ":");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = gridy++;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
        gridBagConstraints.insets = new java.awt.Insets(2, 0, 0, 2);
        jPanel3.add(jLabel_Creator, gridBagConstraints);

        jTextField_Creator = new MAccoutnTextField(publisher);
        jTextField_Creator.setEditable(false);
        //	jTextField_Creator.setText(publisher.toString());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = gridy;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
        gridBagConstraints.weightx = 0.2;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 0);
        jPanel3.add(jTextField_Creator, gridBagConstraints);


        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        // gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(0, 8, 8, 8);
        add(jPanel3, gridBagConstraints);

        // jPanel_Image.setBorder(javax.swing.BorderFactory.createLineBorder(new
        // java.awt.Color(0, 0, 0)));
        jPanel_Image.setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        // gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        // gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        // gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 0.6;
        gridBagConstraints.insets = new java.awt.Insets(0, 8, 8, 0);
        add(jPanel_Image, gridBagConstraints);

        // jLabel2.setText("jLabel2");
        byte[] personImageBytes = person.getImage();
        if (personImageBytes != null && personImageBytes.length > 10) {
            image = new ImageIcon(personImageBytes);
            int x = image.getIconWidth();
            int y = image.getIconHeight();

            int x1 = 250;
            double k = ((double) x / (double) x1);
            y = (int) ((double) y / k);

            if (y != 0) {
                jLabel2.setIcon(new ImageIcon(image.getImage().getScaledInstance(x1, y, 1)));
            }

            jLabel2.setCursor(new Cursor(Cursor.HAND_CURSOR));

            jLabel2.addMouseListener(new imageMouseClick());
        }


        // jLabel2.setBorder(javax.swing.BorderFactory.createLineBorder(new
        // java.awt.Color(0, 0, 0)));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1;
        gridBagConstraints.weighty = 1;
        gridBagConstraints.weightx = 0.2;
        gridBagConstraints.weighty = 0.2;
        jPanel_Image.add(jLabel2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 0.1;
        gridBagConstraints.weighty = 0.4;
        gridBagConstraints.insets = new java.awt.Insets(0, 8, 0, 8);
        // add(jScrollPane2, gridBagConstraints);

        javax.swing.JTabbedPane jTabbedPane1 = new javax.swing.JTabbedPane();

        add(jTabbedPane1, gridBagConstraints);

        // statuses panel

        statuses_Library_Panel = new StatusesLibraryPanel(person);

        jTabbedPane1.add(statuses_Library_Panel);

        // Accounts panel
        accounts_Library_Panel = new AccountsLibraryPanel(person);
        jTabbedPane1.add(accounts_Library_Panel);

        // vouch panel
        voush_Library_Panel = new SignLibraryPanel(issue_record);
        jTabbedPane1.add(voush_Library_Panel);


        // created person panel
        person_Maker_Panel = new PersonMakerPanel(person);
        jTabbedPane1.add(person_Maker_Panel);
        // vouched person
        personSignedPanel = new PersonSignedPanel(person);
        jTabbedPane1.add(personSignedPanel);

    }// </editor-fold>

    private void jTextField_NameActionPerformed(java.awt.event.ActionEvent evt) {
        // TODO add your handling code here:
    }

    public void delay_on_Close() {
        statuses_Library_Panel.delay_on_close();
        accounts_Library_Panel.delay_on_close();
        voush_Library_Panel.delay_on_close();
        person_Maker_Panel.delay_on_close();
        personSignedPanel.delay_on_close();

    }

    // End of variables declaration
    class imageMouseClick extends MouseAdapter {
        @Override
        public void mousePressed(MouseEvent e) {

            new ImageCropDialog(image, image.getDescription().equals("jpg") ? BufferedImage.TYPE_INT_RGB : BufferedImage.TYPE_INT_ARGB) {
                @Override
                public void onFinish(BufferedImage image, TypeOfImage typeOfImage, boolean useOriginal) {
                }
            };

        }
    }


}
